/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/
*MEMVAR _HMG_SYSDATA
#include "minigui.ch"
#include "common.ch"
*-----------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
Init Procedure _ComboAdo
*------------------------------------------------------------------------------*
	InstallEventHandler  ( 'ComboAdoEventHandler' )
	InstallMethodHandler ( 'Refresh' , '_DataComboRefreshAdo' )
	InstallMethodHandler ( 'Value' , '_GetValueAdo' )
	InstallMethodHandler ( 'Change' , '_ChangeAdo' )
Return

Function _DefineComboAdo ( ControlName, ;
			ParentForm, ;
			x, ;
			y, ;
			w, ;
			rows, ;  // Recordset requerido
			value, ;
			fontname, ;
			fontsize, ;
			tooltip, ;
			changeprocedure, ;
			h, ;
			gotfocus, ;
			lostfocus, ;
			uEnter, ;
			HelpId, ;
			invisible, ;
			notabstop, ;
			sort , ;
			bold, ;
			italic, ;
			underline, ;
			strikeout , ;
			itemsource , ;    // Nombre Campo a visualizar requerido
			valuesource , ;   // Nombre Campo a retornar requerido
			displaychange , ;
			ondisplaychangeprocedure , ;
			break , ;
			GripperText , aImage , DroppedWidth , dropdownprocedure , closeupprocedure )
*-----------------------------------------------------------------------------*
Local i , cParentForm , mVar , ControlHandle , FontHandle , rcount := 0 , BackRec , cset := 0 , WorkArea , cField , ContainerHandle := 0 , k := 0
Local aRet := {}
Local ImageListHandle := Nil
Local aTemp
Local ImageSource
Local cImageWorkArea
Local cImageField
	
	DEFAULT w               TO 120
	DEFAULT h               TO 150
	DEFAULT changeprocedure TO ""
	DEFAULT gotfocus	TO ""
	DEFAULT lostfocus	TO ""
	DEFAULT invisible	TO FALSE
	DEFAULT notabstop	TO FALSE
	DEFAULT sort		TO FALSE
	DEFAULT GripperText	TO ""
	DEFAULT DroppedWidth	TO w

	if rows:recordcount = 0
		MsgMiniGuiError ("The recordset is empty. Program Terminated" )
	endif
	
	if valtype( rows ) != 'O'
		MsgMiniGuiError ("The recordset not defined. Program Terminated" )
	endif
		
	if _HMG_SYSDATA [ 264 ] = TRUE
		ParentForm := _HMG_SYSDATA [ 223 ]
		if .Not. Empty (_HMG_SYSDATA [ 224 ]) .And. ValType(FontName) == "U"
			FontName := _HMG_SYSDATA [ 224 ]
		EndIf
		if .Not. Empty (_HMG_SYSDATA [ 182 ]) .And. ValType(FontSize) == "U"
			FontSize := _HMG_SYSDATA [ 182 ]
		EndIf
	endif

	if _HMG_SYSDATA [ 183 ] > 0
		x 			:= x + _HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]]
		y 			:= y + _HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]]
		ParentForm 	:= _HMG_SYSDATA [ 332 ] [_HMG_SYSDATA [ 183 ]]
	EndIf

	If .Not. _IsWindowDefined (ParentForm)
		MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated" )
	Endif

	If _IsControlDefined (ControlName,ParentForm)
		MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program Terminated" )
	endif

	if ValType ( ItemSource ) = 'U' 
		MsgMiniGuiError ("You must declared ItemSource with valid fieldname. Program Terminated" )
	EndIf

	if ValType ( ValueSource ) = 'U' 
		MsgMiniGuiError ("You must declared ValueSource with valid fieldname. Program Terminated" )
	EndIf
	
	if valtype ( itemsource ) = 'C'
		if Rat(',', Itemsource ) != 0
			cImageField := subs(ItemSource, 1, rat ( ',', ItemSource ) - 1 )
			cField 		:= subs(ItemSource, rat(',',Itemsource )+1 )
		else
			cField 		:= Itemsource
		endif
	EndIf

	if valtype(value) == "U"
		value := 0
	endif

	mVar 		:= '_' + ParentForm + '_' + ControlName
	cParentForm := ParentForm
	ParentForm 	:= GetFormHandle (ParentForm)

	if valtype(x) == "U" .or. valtype(y) == "U"
		_HMG_SYSDATA [ 216 ]	:= 'COMBOBOXADO'
		i := GetFormIndex ( cParentForm )
		If i > 0
			If ValType ( aImage ) == 'U'		
				ControlHandle := InitComboBox ( _HMG_SYSDATA [ 87 ] [i], 0, x, y, w, '', 0 , h, invisible, notabstop, sort, displaychange , _HMG_SYSDATA [ 250 ] , DroppedWidth )
			Else
				aRet		:= InitImageCombo ( _HMG_SYSDATA [ 87 ] [i] , y , x , w , h , aImage , displaychange , .Not. invisible , .Not. notabstop , IF ( WINMAJORVERSIONNUMBER() + ( WINMINORVERSIONNUMBER() / 10 ) > 5.1 , .T. , .F. ) , DroppedWidth )
				ControlHandle	:= aRet [1]
				ImageListHandle	:= aRet [2]
			EndIf

			if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
				FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
			Else
				FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)
			endif

			AddSplitBoxItem ( Controlhandle , _HMG_SYSDATA [ 87 ] [i] , w , break , GripperText , w , , _HMG_SYSDATA [ 258 ] )
			Containerhandle := _HMG_SYSDATA [ 87 ] [i]
		EndIf

	else

		If ValType ( aImage ) == 'U'
			ControlHandle := InitComboBox ( ParentForm, 0, x, y, w, '', 0 , h, invisible, notabstop, sort , displaychange , _HMG_SYSDATA [ 250 ] , DroppedWidth )
		Else
			aRet		:= InitImageCombo ( ParentForm , y , x , w , h , aImage , displaychange , .Not. invisible , .Not. notabstop , IF ( WINMAJORVERSIONNUMBER() + ( WINMINORVERSIONNUMBER() / 10 ) > 5.1 , .T. , .F. ) , DroppedWidth )
			ControlHandle	:= aRet [1]
			ImageListHandle	:= aRet [2]
		EndIf

		if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
			FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
		Else
			FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)
		endif

	endif

	If _HMG_SYSDATA [ 265 ] = TRUE
		aAdd ( _HMG_SYSDATA [ 142 ] , Controlhandle )
	EndIf

	if valtype(uEnter) == "U"
		uEnter := ""
	endif

	if valtype(tooltip) != "U"
		SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
	endif

	k := _GetControlFree()

	Public &mVar. := k

	_HMG_SYSDATA [  1 ] [k] := "COMBOADO" 
	_HMG_SYSDATA [  2 ] [k] := ControlName 
	_HMG_SYSDATA [  3 ] [k] := ControlHandle 
	_HMG_SYSDATA [  4 ] [k] := ParentForm 
	_HMG_SYSDATA [  5 ] [k] := 0 
	_HMG_SYSDATA [  6 ] [k] := ondisplaychangeprocedure 
	_HMG_SYSDATA [  7 ] [k] := cField 
	_HMG_SYSDATA [  8 ] [k] := Value 
	_HMG_SYSDATA [  9 ] [k] := Nil
	_HMG_SYSDATA [ 10 ] [k] := lostfocus 
	_HMG_SYSDATA [ 11 ] [k] := gotfocus 
	_HMG_SYSDATA [ 12 ] [k] := changeprocedure 
	_HMG_SYSDATA [ 13 ] [k] := FALSE 
	_HMG_SYSDATA [ 14 ] [k] := cImageField
	_HMG_SYSDATA [ 15 ] [k] := ImageListHandle
	_HMG_SYSDATA [ 16 ] [k] := uEnter 
	_HMG_SYSDATA [ 17 ] [k] := {rows, cParentform,ControlName} 
	_HMG_SYSDATA [ 18 ] [k] := y 
	_HMG_SYSDATA [ 19 ] [k] := x 
	_HMG_SYSDATA [ 20 ] [k] := w 
	_HMG_SYSDATA [ 21 ] [k] := h 
	_HMG_SYSDATA [ 22 ] [k] := WorkArea 
	_HMG_SYSDATA [ 23 ] [k] := iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 24 ] [k] := iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 25 ] [k] := "" 
	_HMG_SYSDATA [ 26 ] [k] := ContainerHandle  
	_HMG_SYSDATA [ 27 ] [k] := fontname 
	_HMG_SYSDATA [ 28 ] [k] := fontsize 
	_HMG_SYSDATA [ 29 ] [k] := {bold,italic,underline,strikeout} 
	_HMG_SYSDATA [ 30 ] [k] := tooltip  
	_HMG_SYSDATA [ 31 ] [k] := 0  
	_HMG_SYSDATA [ 32 ] [k] := 0  
	_HMG_SYSDATA [ 33 ] [k] := valuesource  
	_HMG_SYSDATA [ 34 ] [k] := if(invisible,FALSE,TRUE) 
	_HMG_SYSDATA [ 35 ] [k] := HelpId 
	_HMG_SYSDATA [ 36 ] [k] := FontHandle 
	_HMG_SYSDATA [ 37 ] [k] := closeupprocedure
	_HMG_SYSDATA [ 38 ] [k] := .T. 
	_HMG_SYSDATA [ 39 ] [k] := dropdownprocedure
	_HMG_SYSDATA [ 40 ] [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

	If DisplayChange == .T.
		_HMG_SYSDATA [ 31 ] [k] := FindWindowEx( Controlhandle , 0, "Edit", Nil )
	EndIf

	If  ValType( rows ) == "O"  
		rows:Movefirst()
		Do While ! rows:eof()
			rcount++
	    	if value == rows:absoluteposition
				cset := rcount
			EndIf
			
			If ValType ( aImage ) = 'U'        	
				ComboAddString (	ControlHandle, ;
									rows:fields(cField):value )                 
			else
				ImageComboAddItem ( ControlHandle , ;
									rows:fields(cImageField):value , ;
									rows:fields(cField):value , ;
									-1 )
			endif				
			rows:movenext()
		EndDo	      
		
		rows:MoveFirst()
		ComboSetCurSel (ControlHandle,cset)
	EndIf

	if valtype ( ItemSource ) != 'U'
		if k > 0
			aAdd ( _HMG_SYSDATA [ 89 ]	[ GetFormIndex ( cParentForm ) ] , k )
		Else
			aAdd ( _HMG_SYSDATA [ 89 ]	[ GetFormIndex ( cParentForm ) ] , Len (_HMG_SYSDATA [3]) )
		EndIf
	EndIf
	
	If ValType ( aImage ) <> 'U'

		_HMG_SYSDATA [ 32 ] [k] := SendMessage( Controlhandle, 1030 , 0 , 0 )

	EndIf

Return Nil

*------------------------------------------------------------------------------*
Function ComboAdoEventHandler( hWnd, nMsg, wParam, lParam )
*------------------------------------------------------------------------------*
	Local i
	Local RetVal := Nil
	Local ControlCount := Len( _HMG_SYSDATA[3] )
	
	#define NM_CUSTOMDRAW	(-12)
	#define WM_COMMAND      0x0111
	#define CBN_SELCHANGE	1
	#define CBN_KILLFOCUS	4
	#define CBN_SETFOCUS	3
	#define CBN_CLOSEUP 	8
	#define CBN_DROPDOWN 	7
	#define CBN_EDITCHANGE	5
	#define CTRL_HANDLE 	3
	#define BN_CLICKED	0
	#define BN_SETFOCUS	6
	#define BN_KILLFOCUS	7
	
	i := Ascan ( _HMG_SYSDATA [ CTRL_HANDLE ] , lParam )
                       
	if nMsg == NM_CUSTOMDRAW

		If i > 0
			_DataComboRefreshAdo (_HMG_SYSDATA[17][i][2], _HMG_SYSDATA[17][i][3])
		Endif		
		
	elseif nMsg ==  WM_COMMAND
		// procesa controles por handle
		i := Ascan ( _HMG_SYSDATA [ CTRL_HANDLE ] , lParam )
			
		if i > 0
			* ComboBox Change ..................................
	    	
			If  HIWORD(wParam) == CBN_SELCHANGE .And. _HMG_SYSDATA [1][i] == 'COMBOADO'			
				_ChangeAdo(i)
				_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [i] , i )				
				Return 0
			endif		
			*--- agregado desde aqui
			* ComboBox LostFocus ..................................
        	
			If HIWORD(wParam) == CBN_KILLFOCUS .And. _HMG_SYSDATA [1] [i] == 'COMBOADO'
				_DoControlEventProcedure ( _HMG_SYSDATA [10] [i] , i )
				Return 0
			EndIf
			
			* ComboBox GotFocus ...................................
			
			If HIWORD(wParam) == CBN_SETFOCUS  .And. _HMG_SYSDATA [1] [i] == 'COMBOADO'
				VirtualChildControlFocusProcess ( _HMG_SYSDATA [3] [i] , _HMG_SYSDATA [4] [i] )
				_DoControlEventProcedure ( _HMG_SYSDATA [ 11 ] [i] , i )
				_ChangeAdo(i)
				Return 0
			EndIf
			
			* ComboBox OnDropDown .....................................
			
			If  HIWORD(wParam) == CBN_DROPDOWN .And. _HMG_SYSDATA [1][i] == 'COMBOADO'
				_DoControlEventProcedure ( _HMG_SYSDATA [ 39 ] [i] , i )
				Return 0
			endif
			
			* ComboBox OnCloseUp .....................................
			
			If  HIWORD(wParam) == CBN_CLOSEUP .And. _HMG_SYSDATA [1][i] == 'COMBOADO'
				_DoControlEventProcedure ( _HMG_SYSDATA [ 37 ] [i] , i )
				Return 0
			endif
			
			* Process Combo Display Area Change ...................
        	
			If HIWORD(wParam) == CBN_EDITCHANGE .And. _HMG_SYSDATA [1] [i] == 'COMBOADO'
				_DoControlEventProcedure ( _HMG_SYSDATA [  6 ] [i] , i )
				Return 0
			EndIf
		endif
		
		// procesa teclas
		i = Ascan( _HMG_SYSDATA[ 3 ] , GetFocus() )

		IF i > 0
			if _HMG_SYSDATA [1] [i] = "COMBOADO" .and. ( HiWord(wParam) == 0  .And. LoWord(wParam) == 1 )
				_DoControlEventProcedure ( _HMG_SYSDATA [ 16 ] [i] , i )
				If _HMG_SYSDATA [ 255 ] == .T.
					_SetNextFocus()
				EndIf
				Return 0
			EndIf
		ELSE
			For i := 1 To ControlCount
				if _HMG_SYSDATA [1] [i] = "COMBOADO" .and. ( HiWord(wParam) == 0  .And. LoWord(wParam) == 1 )
					if _HMG_SYSDATA [ 31 ] [i] == GetFocus()
						_DoControlEventProcedure ( _HMG_SYSDATA [ 16 ] [i] , i ) 
						If _HMG_SYSDATA [ 255 ] == .T.
							_SetNextFocus()
						EndIf
						Exit
					EndIf
				EndIf
			Next i
			
			* ComboBox (Image) ..............................
	
			i := Ascan ( _HMG_SYSDATA [32] , GetFocus() )

			If  i > 0   
				If _HMG_SYSDATA [1] [i] = "COMBOADO" .and. ( HiWord(wParam) == 0  .And. LoWord(wParam) == 1 )
					_DoControlEventProcedure ( _HMG_SYSDATA [ 16 ] [i] , i ) 
					If _HMG_SYSDATA [ 255 ] == .T.
						_SetNextFocus()
					EndIf
				EndIf
			EndIf
			Return 0
		ENDIF		
		
	endif

Return RetVal

*-----------------------------------------------------------------------------*
Procedure _DataComboRefreshAdo (ParentForm, ControlName)
*-----------------------------------------------------------------------------*
	Local BackRec , WorkArea , cField , cImageField , xCurrentValue , Tmp
	Local i := GetControlIndex( CONTROLNAME, PARENTFORM )
	local Row 	:= 0
	Local lImage 
	
	cField 		:= _HMG_SYSDATA [ 7] [i]
	cImageField := _HMG_SYSDATA [14] [i]
	WorkArea 	:= _HMG_SYSDATA [17] [i] [1]
	BackRec 	:= WorkArea:AbsolutePosition
	lImage		:= if( _HMG_SYSDATA[15] [i] == Nil, .F., .T. )
	Row			:= ComboGetCursel ( _HMG_SYSDATA[3][i] )
	if WorkArea:Recordcount > 0
		Workarea:MoveFirst()
		ComboboxReset ( _HMG_SYSDATA [3] [i] )
		Do While ! WorkArea:Eof()
			if lImage 
				ComboAddString ( _HMG_SYSDATA [3] [i] , WorkArea:fields(cField):value )                 
				ImageComboAddItem ( _HMG_SYSDATA [3] [i] , WorkArea:fields(cImageField):value , WorkArea:fields(cField):value , -1 )
			else
				ComboAddString ( _HMG_SYSDATA [3] [i] , WorkArea:fields(cField):value )
			endif
			WorkArea:MoveNext()
		EndDo	      
		if Row <= 0 .and. WorkArea:RecordCount > 0
			Row = 1
		endif
		
		If Row > 0 .And. Row <= WorkArea:Recordcount
			_SetValue ( , , Row, i )	
		EndIf
		
		WorkArea:Movefirst()
		WorkArea:Move( Row-1 )
		ComboSetCurSel (_HMG_SYSDATA[3][i],Row)
	endif
	
Return

Procedure _ChangeAdo(idx)
	Local cParent, cControl
	Local Row 
	Local WorkArea	
	Workarea= _HMG_SYSDATA[17][idx][1]
	cParent = _HMG_SYSDATA[17][idx][2]
	cControl= _HMG_SYSDATA[17][idx][3]
	Row 	= ComboGetCursel ( _HMG_SYSDATA[3][idx] )
	if Row > 0 .And. Row <= WorkArea:RecordCount 
		if WorkArea:Recordcount > 0
			WorkArea:MoveFirst()
			WorkArea:Move( ROW-1 )
		endif
	endif
Return 

Function _GetValueAdo( ParentForm, ControlName )
	Local i := GetControlIndex( ControlName, ParentForm )
	Local RetVal
	Local cValueSource
	Local Row := ComboGetCursel ( _HMG_SYSDATA[3][i] )
	Local WorkArea
	
	WorkArea	:= _HMG_SYSDATA[17][i][1]
	cValueSource:= _HMG_SYSDATA[33][i]
	if Workarea:Recordcount > 0
		RetVal		:= WorkArea:Fields( cValueSource ):Value
    	
		if Row > 0 .or. Row <= WorkArea:RecordCount 	
			WorkArea:MoveFirst()
			WorkArea:Move( ROW-1 )
			if WorkArea:bof()
				WorkArea:Movefirst()
			endif
			RetVal :=WorkArea:Fields( cValueSource ):Value
		endif
	endif
return RetVal
